#ifndef EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH
#define EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "canvas/evas_signal_interface.eo.h"
}


struct evas_signal_interface
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit evas_signal_interface(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief Copy Constructor.
   ///
   evas_signal_interface(evas_signal_interface const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~evas_signal_interface() {}

   static Eo_Class const* _eo_class()
   {
      return(EVAS_SIGNAL_INTERFACE_CLASS);
   }

private:
};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas_signal_interface >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::evas_signal_interface >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::evas_signal_interface>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
template<>
struct extension_inheritance< ::evas_signal_interface>
{
   template <typename T>
   struct type
   {
      operator ::evas_signal_interface() const
      {
         return ::evas_signal_interface(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::evas_signal_interface>)
{
   return (EVAS_SIGNAL_INTERFACE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH

